(define-module (ui root ajax)
    :use-module (alterator ajax)
    :use-module (alterator algo)
    :use-module (alterator woo)
    :use-module (alterator effect)
    :export (init
             init-passwordbox
             commit-passwordbox
             ))

;; private passwordbox API

(define (generate-passwordbox)
  (form-update-value-list
    '("passwd_auto")
    (woo-call "/vnc/generate_password")))

(define (update-passwordbox)
  (form-update-value "passwd_1" "")
  (form-update-value "passwd_2" "")
  (form-update-value "passwd_auto" "")
  (form-update-value "auto" #f)
  (generate-passwordbox)
  (update-effect))

;; public passwordbox API

(define (init-passwordbox)
  ;; effects
  (effect-show "passwd_1" "auto" #f)
  (effect-show "passwd_2" "auto" #f)
  (effect-show "passwd_auto" "auto" #t)
  (effect-show "generate_button" "auto" #t)
  ;; generate button
  (form-bind "generate_button" "click" generate-passwordbox)
  (update-passwordbox))

(define (commit-passwordbox)
  (apply woo-call "/vnc/change_password"
         'language (form-value "language")
	 (form-value-list '("auto" "passwd_1" "passwd_2" "passwd_auto")))
  (update-passwordbox))

;;; current form specific API

(define (ui-write)
  (form-update-visibility "passwd_message" #f)
  (catch/message
    (lambda()
        (commit-passwordbox)
	(form-update-visibility "passwd_message" #t))))

(define (init)
  ;; password
  (init-passwordbox)
  (init-effect)
  (form-bind "apply_button" "click" ui-write))
